      program test
      IMPLICIT NONE
      INCLUDE 'mpif.h'
      integer a,andrew,x,ifetch,dfetch,ffetch
      doubleprecision gp_dfetch
      integer gp_ifetch
      real gp_ffetch
      real b,david
      integer debug,y,z
      doubleprecision c,john,MINFLT,themin
      INTEGER t, t0, tswap, tdump, tmax, INDI01
      INTEGER IERR00,NPROCS,DIMPGR(1),PARINT(100),COMM2D,PPRANK
      DOUBLE PRECISION PARDPR(100)
      LOGICAL PERIOD(1),RORDER
      PARAMETER (RORDER = .FALSE.)
C
      include 'parinclude.f'
C.... Starting MPI.
      CALL MPI_INIT(IERR00)
C.... Preliminaries
      DIMPGR(1) = 0
      PERIOD(1) = .FALSE.
C.... Creating the virtual topology.
      CALL MPI_COMM_SIZE(MPI_COMM_WORLD,NPROCS,IERR00)
      CALL MPI_DIMS_CREATE(NPROCS,1,DIMPGR,IERR00)
      CALL MPI_CART_CREATE(MPI_COMM_WORLD,1,DIMPGR,PERIOD,RORDER,
     &                     COMM2D,IERR00)
      CALL MPI_COMM_RANK(COMM2D,PPRANK,IERR00)
C.... Reading data.
      DO INDI01 = 1, 100
         PARINT(INDI01) = 0
	 PARDPR(INDI01) = 0.D0
      ENDDO
      IF(PPRANK.EQ.0) THEN

      themin = minflt()

      debug=1

      WRITE(6,*) "_____________________________________________________"
      WRITE(6,*) ""
      WRITE(6,*) "           Testing Fortran functions                 "
      WRITE(6,*) "           minflt() =",the min
      WRITE(6,*) ""
      WRITE(6,*) "_____________________________________________________"

      x = ifetch("andrew",a)
      y = ffetch("david",b)
      z = dfetch("john",c)

      if(debug.eq.1) THEN
      write (6,*) "int andrew=",andrew, " read=",a, " err=", x
      write (6,*) "float david=",david, " read=",b, " err=", y
      write (6,*) "double john=",john,  " read=",c, " err=", z
      ENDIF

      if(andrew.ne.a.or.
     $   (abs(david-b)).gt.themin.or.
     $   (abs(john-c)).gt.themin) 
     $  then
         write(6,*) "abs(david-b)  = ",abs(david-b)
         write(6,*) "abs(john-c)  = " ,abs(john-c)
         stop 'fgp simple test failed'
      endif



      WRITE(6,*) "_____________________________________________________"
      WRITE(6,*) ""
      WRITE(6,*) "           Testing Fortran GP_xxxx functions         "
      WRITE(6,*) "_____________________________________________________"

      debug = GP_ifetch("debug",0,"SEVERE")

      a = GP_ifetch("andrew",0,"DEFAULT")
c     b = GP_ffetch("david",345.,"DEFAULT")
      c = GP_dfetch("john",0.D0,"DEFAULT")

      if(debug.eq.2) then
         a = GP_ifetch("andrew",0,"WARNING")
cc       b = GP_ffetch("david",0.,"WARNING")
         c = GP_dfetch("john",0.D0,"WARNING")

         a = GP_ifetch("noandrew",0,"WARNING")
c        b = GP_ffetch("nodavid",345.,"WARNING")
         c = GP_dfetch("nojohn",0.D0,"WARNING")

         a = GP_ifetch("andrew",0,"SEVERE")
cc       b = GP_ffetch("david",0.,"SEVERE")
         c = GP_dfetch("john",0.D0,"SEVERE")

         a = GP_ifetch("noandrew",0,"SEVERE")
c        b = GP_ffetch("nodavid",0.,"SEVERE")
         c = GP_dfetch("nojohn",0.D0,"SEVERE")
      endif

      if(debug.eq.1) THEN
      write (6,*) "int andrew=",andrew, " read=",a, " err=", x
c     write (6,*) "float david=",david, " read=",b, " err=", y
      write (6,*) "double john=",john,  " read=",c, " err=", z
      ENDIF

      if(andrew.ne.a.or.
     $   (abs(david-b)).gt.themin.or.
     $   (abs(john-c)).gt.themin) 
     $    stop 'fgp simple test failed'

      write(*,*) 'PPRANK ',PPRANK,' finished'
      ELSE
      write(*,*) 'PPRANK ',PPRANK,' finished'
      ENDIF

      
      CALL MPI_FINALIZE(IERR00)
C

      STOP
      END
